unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MailMerge, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    btnMerge: TButton;
    Label1: TLabel;
    edtEmployeeName: TEdit;
    lblClients: TLabel;
    mmoClients: TMemo;
    StatusBar1: TStatusBar;
    Label2: TLabel;
    mmoStatus: TMemo;
    btnPrint: TButton;
    lbxDataSource: TComboBox;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure MailMergeStatusMessage(Sender: TObject);
    procedure btnMergeClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure lbxDataSourceChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    MailMerge: TMailMerge;

    // Give all child controls and the child-child-etc controls the right taborder:
    procedure SetChildTaborders(Parent: TWinControl);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  I: TMailMergeDatasource;
begin
  MailMerge := TMailMerge.Create(Self);
  MailMerge.OnStatusMessage := MailMergeStatusMessage;
  for I := Low(I) to High(I) do
    lbxDataSource.Items.Add(TMailMergeDatasourceNames[I]);
  lbxDataSource.ItemIndex := Integer(MailMerge.DataSource);
  SetChildTaborders(Self);
end;

procedure TForm1.MailMergeStatusMessage(Sender: TObject);
begin
  StatusBar1.SimpleText := TMailMerge(Sender).StatusMessage;
  mmoStatus.Lines.Add(TMailMerge(Sender).StatusMessage);
end;

procedure TForm1.btnMergeClick(Sender: TObject);
var
  I: Integer;
begin
  MailMerge.Clear;
  MailMerge.DocumentName := IncludeTrailingBackslash(ExtractFilePath(Application.ExeName)) + 'template.doc';
  MailMerge.Columns := 'CustomerName;EmployeeName';
  for I := 0 to mmoClients.Lines.Count - 1 do
  begin
    if mmoClients.Lines[I] <> '' then
    begin
      MailMerge.Append;
      MailMerge['CustomerName'] := mmoClients.Lines[I];
      MailMerge['EmployeeName'] := edtEmployeeName.Text;
    end;
  end;
  MailMerge.Merge;
  // Datasource method could have been changed by the component:
  lbxDataSource.ItemIndex := Integer(MailMerge.DataSource);
end;

procedure TForm1.btnPrintClick(Sender: TObject);
begin
  MailMerge.WordDocument.PrintOut(EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam);
end;

procedure TForm1.lbxDataSourceChange(Sender: TObject);
begin
  MailMerge.DataSource := TMailMergeDataSource(lbxDataSource.ItemIndex);
end;

procedure TForm1.SetChildTaborders(Parent: TWinControl);
  procedure MakeItSo(Parent: TWinControl);
  var
    I, L: integer;
    List: TList;
  begin
    List := TList.Create;
    // Examine each component (TComponent) in 'Parent' (TWinControl)
    for I := 0 to Parent.ControlCount - 1 do
    begin
      if Parent.Controls[I] is TWinControl then  // It is a TWinControl, or based on TControl (eg: TMemo is based on TWinControl)
      begin
        if List.Count = 0 then
          L := 0
        else begin
          with Parent.Controls[I] do // Search for a sorted place in our list (sorted by Top, Left):
            for L := 0 to List.Count - 1 do
              if (Top < TControl(List[L]).Top) or
                 ((Top = TControl(List[L]).Top) and (Left < TControl(List[L]).Left)) then
                break;
        end;
        List.Insert(L, Parent.Controls[I]);  // Insert in our list (sorted)
        MakeItSo(TWinControl(Parent.Controls[I])); // Recursivly handle the TWinControls in this TWinControl (if any)
      end;
    end;
    // We have a list of TControls, sorted by position (Top, Left). Set the new TabOrder
    // properties of all this controls:
    for I := 0 to List.Count - 1 do
      TWinControl(List[I]).TabOrder := I;
    List.Free;
  end;
begin
  MakeItSo(Parent);
end;

end.
